
//#define Display_val(v) ((Display *)(v))
//#define Val_Display(dpy) ((value)(dpy))


#define Display_val(v) ((Display *)(Field((v),0)))

static inline value Val_Display(Display * dpy)
{
// Store information to know if the display is currently opened
    CAMLparam0();
    CAMLlocal1( ml_dpy );
    ml_dpy = caml_alloc(2, 0);
    Store_field( ml_dpy, 0, ((value)(dpy)) );
    Store_field( ml_dpy, 1, Val_true );
    CAMLreturn( ml_dpy );
}

#define display_record_closed(dpy) Store_field(dpy, 1, Val_false)
#define display_is_open(dpy) (Field((dpy),1) == Val_true)


#define Val_screenNB Val_int
#define ScreenNB_val Int_val


/* The scruture Screen is here renamed with an additionnal X
   as a way of disambiguation with screen numbers (int) and 
   its conversion macro ScreenNB_val() */
#define Val_XScreen(s) ((value)(s))
#define XScreen_val(v) ((Screen *)(v))


#define XID_val(type,v) ((type) (v))
#define Val_XID(v) ((value) (v))

#define Window_val(v) (XID_val(Window,(v)))
#define Val_Window(xid) (Val_XID((xid)))

#define Pixmap_val(v) (XID_val(Pixmap,(v)))
#define Val_Pixmap(xid) (Val_XID((xid)))


#define XVisualInfo_val(v) ((XVisualInfo *)(v))
#define Val_XVisualInfo(vi) ((value)(vi))

#define Val_Visual(vis) ((value)(vis))
#define Visual_val(v) ((Visual *)(v))

#define VisualID_val(v) ((VisualID)(v))
#define Val_VisualID(v) ((value)(v))


#define UInt_noassert_val(x) ((unsigned int) Long_val(x))
#define UInt_assert_val(x) ((x) > 0 ? UInt_noassert_val(x) : assert(false) )

#define UInt_val UInt_noassert_val
#define Val_uint Val_int


#define ULong_noassert_val(x) ((unsigned long) Long_val(x))
#define ULong_assert_val(x) ((x) > 0 ? ULong_noassert_val(x) : assert(false) )

#define ULong_val ULong_noassert_val
#define Val_ulong Val_long


#define Val_char Val_int

#define Val_none Val_int(0)


/* caml allocs */

/* Default custom_operations */
#define custom_ops(s) \
static struct custom_operations s##_custom_ops = { \
    identifier: #s, \
    finalize:    custom_finalize_default, \
    compare:     custom_compare_default, \
    hash:        custom_hash_default, \
    serialize:   custom_serialize_default, \
    deserialize: custom_deserialize_default \
}

#define copy_obj(type, obj, ml_return) \
  do{ ml_return = caml_alloc_custom( &type##_custom_ops, sizeof(type), 0, 1); \
      memcpy( Data_custom_val(ml_return), &obj, sizeof(type) ); }while(0)

#define alloc_obj(type, ml_return) \
    ml_return = caml_alloc_custom( &type##_custom_ops, sizeof(type), 0, 1);

#define custom_ops_n(s)  custom_ops(s##_n)

#define alloc_n_obj(type, ml_return, n) \
    ml_return = caml_alloc_custom( &type##_n_custom_ops, n * sizeof(type), 0, 1);


